Index: /trunk/bin/acl.cli.php
===================================================================
--- /trunk/bin/acl.cli.php	(revision 467)
+++ /trunk/bin/acl.cli.php	(revision 468)
@@ -5,5 +5,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -12,10 +12,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -113,6 +113,6 @@
         break;
     case 'all' :
-        listObjects('root', 'aro');                               
-        listObjects('root', 'aco');                               
+        listObjects('root', 'aro');
+        listObjects('root', 'aco');
         listObjects('root', 'axo');
         break;
@@ -238,9 +238,9 @@
 but could just as easily be SPICES -> CUISINES -> DISHES. A privilege is
 allowed if a user (ARO) can perform an action (ACO) on something (AXO).
-For example, with an `ARO->ACO->AXO` of `Bob->edit->4`, Bob can edit article 4. 
-If the AXO were omitted (i.e. just `Bob->edit`), this becomes "Bob can edit" 
+For example, with an `ARO->ACO->AXO` of `Bob->edit->4`, Bob can edit article 4.
+If the AXO were omitted (i.e. just `Bob->edit`), this becomes "Bob can edit"
 (he can edit any object).
 
-Each access object is stored as a node in hierarchical tree structures. 
+Each access object is stored as a node in hierarchical tree structures.
 A permission granted to a node is applied to all its children. If a child
 node is specified a different permission that is more specific than
@@ -252,5 +252,5 @@
 
 Where command is any of the following (with arguments):
-    
+
     initdb
     list [aro | aco | axo | all | perms]
@@ -268,8 +268,8 @@
     revoke aro [aco] [axo]
     delete [aro] [aco] [axo]
-    
-
-For the add*, mv*, grant, and revoke commands if any of the optional 
-args are not provided, 'root' is assumed. For the delete command 
+
+
+For the add*, mv*, grant, and revoke commands if any of the optional
+args are not provided, 'root' is assumed. For the delete command
 'null' is considered a wild-card to delete all objects of that type.
 
@@ -297,5 +297,5 @@
     $db =& DB::getInstance();
     global $this_script;
-    
+
     echo "\n";
 
@@ -324,7 +324,7 @@
     $qid = $db->query("SELECT lft, rgt FROM $tbl WHERE name = '" . $db->escapeString($root) . "'");
     list($lft, $rgt) = mysql_fetch_row($qid);
-    
+
     $depth = array();
-    
+
     // Retrieve all descendants of the root node
     $qid = $db->query("SELECT name, lft, rgt, added_datetime FROM $tbl WHERE lft BETWEEN $lft AND $rgt ORDER BY lft ASC");
@@ -334,8 +334,8 @@
             array_pop($depth);
         }
-    
+
         // Display indented node title.
         printf("%-35s %-5s %-5s %s\n", str_repeat('    ', sizeof($depth)) . $name, $lft, $rgt, date($app->getParam('date_format'), strtotime($added_datetime)));
-        
+
         // Add this node to the stack.
         $depth[] = $rgt;
@@ -356,5 +356,5 @@
     $db =& DB::getInstance();
     global $this_script;
-    
+
     // Retrieve access value from db.
     $qid = $db->query("
@@ -371,7 +371,6 @@
     while ($p = mysql_fetch_assoc($qid)) {
         printf("%-25s %-25s %-25s \033[0;%sm%-6s\033[0m %-10s\n", $p['aro'], $p['aco'], $p['axo'], ('allow' == $p['access'] ? '32' : '31'), $p['access'], date($app->getParam('date_format'), strtotime($p['added_datetime'])));
-    }    
-}
-
-
-?>
+    }
+}
+
+
Index: /trunk/bin/file_importer.php
===================================================================
--- /trunk/bin/file_importer.php	(revision 467)
+++ /trunk/bin/file_importer.php	(revision 468)
@@ -123,3 +123,2 @@
 // }
 // 
-// ?>
Index: /trunk/bin/module_maker/_config.inc.php
===================================================================
--- /trunk/bin/module_maker/_config.inc.php	(revision 467)
+++ /trunk/bin/module_maker/_config.inc.php	(revision 468)
@@ -73,3 +73,2 @@
 
 
-?>
Index: /trunk/bin/module_maker/form_template.cli.php
===================================================================
--- /trunk/bin/module_maker/form_template.cli.php	(revision 467)
+++ /trunk/bin/module_maker/form_template.cli.php	(revision 468)
@@ -249,4 +249,2 @@
 
 echo join("\n", $output);
-
-?>
Index: /trunk/bin/module_maker/list_template.cli.php
===================================================================
--- /trunk/bin/module_maker/list_template.cli.php	(revision 467)
+++ /trunk/bin/module_maker/list_template.cli.php	(revision 468)
@@ -36,5 +36,5 @@
     $db_tbl = $_SERVER['argv'][2];
 } else {
-    die(sprintf("Usage: %s site_directory db_table [operation]\nValid operations include: %s", basename($_SERVER['argv'][0]), join(', ', $valid_ops)));
+    die(sprintf("Usage: %s site_directory db_table [operation]\nValid operations include: %s\n", basename($_SERVER['argv'][0]), join(', ', $valid_ops)));
 }
 
@@ -213,4 +213,2 @@
 
 E_O_F;
-
-?>
Index: /trunk/bin/module_maker/module.cli.php
===================================================================
--- /trunk/bin/module_maker/module.cli.php	(revision 467)
+++ /trunk/bin/module_maker/module.cli.php	(revision 468)
@@ -596,4 +596,2 @@
     }
 }
-
-?>
Index: /trunk/bin/module_maker/skel/admin.php
===================================================================
--- /trunk/bin/module_maker/skel/admin.php	(revision 467)
+++ /trunk/bin/module_maker/skel/admin.php	(revision 468)
@@ -4,5 +4,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -11,10 +11,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -236,5 +236,5 @@
 	$db =& DB::getInstance();
 	$app =& App::getInstance();
-	
+
     $lock->select('%DB_TBL%', '%PRIMARY_KEY%', $id);
     if ($lock->isLocked() && !$lock->isMine()) {
@@ -278,5 +278,5 @@
 	$db =& DB::getInstance();
 	$app =& App::getInstance();
-	
+
     $lock->select('%DB_TBL%', '%PRIMARY_KEY%', $id);
     if ($lock->isLocked() && !$lock->isMine()) {
@@ -314,5 +314,5 @@
 	$db =& DB::getInstance();
 	$app =& App::getInstance();
-	
+
     // Remove any stale cached list data.
     $cache->delete('list');
@@ -337,5 +337,5 @@
 	$db =& DB::getInstance();
 	$app =& App::getInstance();
-    
+
     $lock->select('%DB_TBL%', '%PRIMARY_KEY%', $frm['%PRIMARY_KEY%']);
     if ($lock->isLocked() && !$lock->isMine()) {
@@ -364,7 +364,7 @@
     global $tmp_prefs;
     global $cache;
-	$db =& DB::getInstance();	
-	$app =& App::getInstance();
-    
+	$db =& DB::getInstance();
+	$app =& App::getInstance();
+
     $where_clause = '';
 
@@ -379,5 +379,5 @@
     if (getFormData('filter___///__', false)) {
         // Limit by filter.
-        $where_clause .= (empty($where_clause) ? 'WHERE' : 'AND') . " __///__ = '" . $db->escapeString(getFormData('filter___///__')) . "'";
+        $where_clause .= (empty($where_clause) ? 'WHERE' : ' AND') . " __///__ = '" . $db->escapeString(getFormData('filter___///__')) . "'";
     }
 
@@ -425,5 +425,5 @@
         return $list;
     }
-    
+
     // The list was not cached, so issue the real query.
     $qid = $db->query($sql);
@@ -445,5 +445,5 @@
 	$db =& DB::getInstance();
 	$app =& App::getInstance();
-	
+
     if (!is_array($ranks)) {
         $app->logMsg('Saving rank failed, data posted is not an array: ' . $ranks, LOG_ERR, __FILE__, __LINE__);
@@ -476,4 +476,2 @@
     }
 }
-
-?>
Index: /trunk/bin/module_maker/skel/public.php
===================================================================
--- /trunk/bin/module_maker/skel/public.php	(revision 467)
+++ /trunk/bin/module_maker/skel/public.php	(revision 468)
@@ -145,3 +145,2 @@
 include 'footer.ihtml';
 
-?>
Index: /trunk/bin/module_maker/sql.cli.php
===================================================================
--- /trunk/bin/module_maker/sql.cli.php	(revision 467)
+++ /trunk/bin/module_maker/sql.cli.php	(revision 468)
@@ -5,5 +5,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -12,10 +12,10 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
@@ -36,5 +36,5 @@
     $db_tbl = $_SERVER['argv'][2];
 } else {
-    die(sprintf("Usage: %s site_directory db_table [operation]\nValid operations include: %s", basename($_SERVER['argv'][0]), join(', ', $valid_ops)));
+    die(sprintf("Usage: %s site_directory db_table [operation]\nValid operations include: %s\n", basename($_SERVER['argv'][0]), join(', ', $valid_ops)));
 }
 
@@ -218,3 +218,2 @@
 
 echo isset($op) ? '' : "\n\n\n";
-?>
Index: /trunk/bin/module_maker/validation.cli.php
===================================================================
--- /trunk/bin/module_maker/validation.cli.php	(revision 467)
+++ /trunk/bin/module_maker/validation.cli.php	(revision 468)
@@ -309,3 +309,2 @@
     " . join("\n    ", $o) . "
 }";
-?>
Index: /trunk/docs/examples/_config.inc.php
===================================================================
--- /trunk/docs/examples/_config.inc.php	(revision 467)
+++ /trunk/docs/examples/_config.inc.php	(revision 468)
@@ -4,5 +4,5 @@
  * For details visit the project site: <http://trac.strangecode.com/codebase/>
  * Copyright 2001-2012 Strangecode, LLC
- * 
+ *
  * This file is part of The Strangecode Codebase.
  *
@@ -11,15 +11,15 @@
  * Free Software Foundation, either version 3 of the License, or (at your option)
  * any later version.
- * 
+ *
  * The Strangecode Codebase is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
  * details.
- * 
+ *
  * You should have received a copy of the GNU General Public License along with
  * The Strangecode Codebase. If not, see <http://www.gnu.org/licenses/>.
  */
 
-/** 
+/**
  * _config.inc.php lives in the document root of the site/application. It is the beginning of everything.
  *
@@ -28,5 +28,5 @@
  * @since   03 Dec 2005 19:09:32
  */
- 
+
 // The constant __FILE__ must be an absolute directory path, starting with / on unix or C: on windows.
 // To work around a PHP bug always include this config file with: require_once dirname(__FILE__) . '/_config.inc.php';
@@ -39,5 +39,5 @@
 define('COMMON_BASE', realpath(dirname(__FILE__) . '/../'));
 
-// The DocRoot for this application. SITE_BASE is different from $_SERVER['DOCUMENT_ROOT'] because the 
+// The DocRoot for this application. SITE_BASE is different from $_SERVER['DOCUMENT_ROOT'] because the
 // latter does not change when using the apache Alias directive or URL Rewriting to define a site.
 define('SITE_BASE', dirname(__FILE__));
@@ -148,10 +148,10 @@
 require_once 'codebase/lib/Cache.inc.php';
 $cache = new Cache('global');
-$cache->setParam(array('enabled' => true));
+$cache->setParam(array('enabled' => true)); // TODO: Enable caching after site launch.
 
 // Setup CSS files to include. These will always be available.
 require_once 'codebase/lib/CSS.inc.php';
 $css = new CSS();
-$css->setParam(array('cache_css' => false)); /// Enable caching after site launch.
+$css->setParam(array('cache_css' => false)); // TODO: Enable caching after site launch.
 $css->setFile('codebase/css/codebase.inc.css');
 $css->setFile('codebase/css/utilities.inc.css');
@@ -170,3 +170,2 @@
 // require_once 'global/config.inc.php';
 
-?>
Index: /trunk/docs/examples/contact_form/contact.php
===================================================================
--- /trunk/docs/examples/contact_form/contact.php	(revision 467)
+++ /trunk/docs/examples/contact_form/contact.php	(revision 468)
@@ -119,3 +119,2 @@
 }
 
-?>
Index: /trunk/docs/examples/db_auth.inc.php
===================================================================
--- /trunk/docs/examples/db_auth.inc.php	(revision 467)
+++ /trunk/docs/examples/db_auth.inc.php	(revision 468)
@@ -35,3 +35,2 @@
     'db_pass' => '',
 ));
-?>
Index: /trunk/docs/examples/example.cli.php
===================================================================
--- /trunk/docs/examples/example.cli.php	(revision 467)
+++ /trunk/docs/examples/example.cli.php	(revision 468)
@@ -146,3 +146,2 @@
 
 
-?>
Index: /trunk/docs/examples/script_template.php
===================================================================
--- /trunk/docs/examples/script_template.php	(revision 467)
+++ /trunk/docs/examples/script_template.php	(revision 468)
@@ -60,3 +60,2 @@
 
 
-?>
Index: /trunk/lib/ACL.inc.php
===================================================================
--- /trunk/lib/ACL.inc.php	(revision 467)
+++ /trunk/lib/ACL.inc.php	(revision 468)
@@ -39,7 +39,9 @@
 class ACL {
 
+    // A place to keep an object instance for the singleton pattern.
+    private static $instance = null;
+
     // Configuration parameters for this object.
-    var $_params = array(
-
+    private $_params = array(
         // If false nothing will be cached or retrieved. Useful for testing realtime data requests.
         'enable_cache' => true,
@@ -52,5 +54,5 @@
      * Constructor.
      */
-    function ACL()
+    public function __construct()
     {
 		$app =& App::getInstance();
@@ -73,13 +75,11 @@
      * @static
      */
-    static function &getInstance()
-    {
-        static $instance = null;
-
-        if ($instance === null) {
-            $instance = new ACL();
-        }
-
-        return $instance;
+    public static function &getInstance()
+    {
+        if (self::$instance === null) {
+            self::$instance = new self();
+        }
+
+        return self::$instance;
     }
 
@@ -91,5 +91,5 @@
      * @param  array    $params     Array of parameters (key => val pairs).
      */
-    function setParam($params)
+    public function setParam($params)
     {
 		$app =& App::getInstance();
@@ -110,5 +110,5 @@
      * @return mixed               Configured parameter value.
      */
-    function getParam($param)
+    public function getParam($param)
     {
 		$app =& App::getInstance();
@@ -129,5 +129,5 @@
      * @since   04 Jun 2006 16:41:42
      */
-    function initDB($recreate_db=false)
+    public function initDB($recreate_db=false)
     {
 		$app =& App::getInstance();
@@ -224,5 +224,5 @@
     * @since    14 Jun 2006 22:39:29
     */
-    function add($name, $parent=null, $type)
+    public function add($name, $parent=null, $type)
     {
         $app =& App::getInstance();
@@ -287,13 +287,13 @@
 
     // Alias functions for the different object types.
-    function addRequestObject($name, $parent=null)
+    public function addRequestObject($name, $parent=null)
     {
         return $this->add($name, $parent, 'aro');
     }
-    function addControlObject($name, $parent=null)
+    public function addControlObject($name, $parent=null)
     {
         return $this->add($name, $parent, 'aco');
     }
-    function addXtraObject($name, $parent=null)
+    public function addXtraObject($name, $parent=null)
     {
         return $this->add($name, $parent, 'axo');
@@ -311,5 +311,5 @@
     * @since    14 Jun 2006 22:39:29
     */
-    function remove($name, $type)
+    public function remove($name, $type)
     {
         $app =& App::getInstance();
@@ -368,13 +368,13 @@
 
     // Alias functions for the different object types.
-    function removeRequestObject($name)
+    public function removeRequestObject($name)
     {
         return $this->remove($name, 'aro');
     }
-    function removeControlObject($name)
+    public function removeControlObject($name)
     {
         return $this->remove($name, 'aco');
     }
-    function removeXtraObject($name)
+    public function removeXtraObject($name)
     {
         return $this->remove($name, 'axo');
@@ -393,5 +393,5 @@
     * @since    14 Jun 2006 22:39:29
     */
-    function move($name, $new_parent, $type)
+    public function move($name, $new_parent, $type)
     {
         $app =& App::getInstance();
@@ -490,13 +490,13 @@
 
     // Alias functions for the different object types.
-    function moveRequestObject($name, $new_parent=null)
+    public function moveRequestObject($name, $new_parent=null)
     {
         return $this->move($name, $new_parent, 'aro');
     }
-    function moveControlObject($name, $new_parent=null)
+    public function moveControlObject($name, $new_parent=null)
     {
         return $this->move($name, $new_parent, 'aco');
     }
-    function moveXtraObject($name, $new_parent=null)
+    public function moveXtraObject($name, $new_parent=null)
     {
         return $this->move($name, $new_parent, 'axo');
@@ -516,5 +516,5 @@
     * @since    15 Jun 2006 01:58:48
     */
-    function grant($aro=null, $aco=null, $axo=null, $access='allow')
+    public function grant($aro=null, $aco=null, $axo=null, $access='allow')
     {
         $app =& App::getInstance();
@@ -573,5 +573,5 @@
     * @since    15 Jun 2006 04:35:54
     */
-    function revoke($aro=null, $aco=null, $axo=null)
+    public function revoke($aro=null, $aco=null, $axo=null)
     {
         return $this->grant($aro, $aco, $axo, 'deny');
@@ -591,5 +591,5 @@
     * @since    20 Jun 2006 20:16:12
     */
-    function delete($aro=null, $aco=null, $axo=null)
+    public function delete($aro=null, $aco=null, $axo=null)
     {
         $app =& App::getInstance();
@@ -650,5 +650,5 @@
     * @since    15 Jun 2006 03:58:23
     */
-    function check($aro, $aco=null, $axo=null)
+    public function check($aro, $aco=null, $axo=null)
     {
         $app =& App::getInstance();
@@ -713,5 +713,5 @@
     * @since    20 Jan 2014 12:09:03
     */
-    function requireAllow($aro, $aco=null, $axo=null, $message='', $type=MSG_NOTICE, $file=null, $line=null)
+    public function requireAllow($aro, $aco=null, $axo=null, $message='', $type=MSG_NOTICE, $file=null, $line=null)
     {
 		$app =& App::getInstance();
@@ -725,5 +725,2 @@
 
 } // End class.
-
-
-?>
Index: /trunk/lib/App.inc.php
===================================================================
--- /trunk/lib/App.inc.php	(revision 467)
+++ /trunk/lib/App.inc.php	(revision 468)
@@ -42,21 +42,24 @@
 class App {
 
+    // A place to keep an object instance for the singleton pattern.
+    private static $instance = null;
+
     // Namespace of this application instance.
-    var $_ns;
+    private $_ns;
 
     // If $app->start has run successfully.
-    var $running = false;
+    public $running = false;
 
     // Instance of database object.
-    var $db;
+    public $db;
 
     // Array of query arguments will be carried persistently between requests.
-    var $_carry_queries = array();
+    private $_carry_queries = array();
 
     // Dictionary of global application parameters.
-    var $_params = array();
+    private $_params = array();
 
     // Default parameters.
-    var $_param_defaults = array(
+    private $_param_defaults = array(
 
         // Public name and email address for this application.
@@ -162,4 +165,21 @@
 
     /**
+     * Constructor.
+     */
+    public function __construct($namespace='')
+    {
+        // Set namespace of application instance.
+        $this->_ns = $namespace;
+
+        // Initialize default parameters.
+        $this->_params = array_merge($this->_params, $this->_param_defaults);
+
+        // Begin timing script.
+        require_once dirname(__FILE__) . '/ScriptTimer.inc.php';
+        $this->timer = new ScriptTimer();
+        $this->timer->start('_app');
+    }
+
+    /**
      * This method enforces the singleton pattern for this class. Only one application is running at a time.
      *
@@ -169,30 +189,12 @@
      * @static
      */
-    static function &getInstance($namespace='')
-    {
-        static $instance = null;
-
-        if ($instance === null) {
-            $instance = new App($namespace);
-        }
-
-        return $instance;
-    }
-
-    /**
-     * Constructor.
-     */
-    function App($namespace='')
-    {
-        // Set namespace of application instance.
-        $this->_ns = $namespace;
-
-        // Initialize default parameters.
-        $this->_params = array_merge($this->_params, $this->_param_defaults);
-
-        // Begin timing script.
-        require_once dirname(__FILE__) . '/ScriptTimer.inc.php';
-        $this->timer = new ScriptTimer();
-        $this->timer->start('_app');
+    public static function &getInstance($namespace='')
+    {
+        if (self::$instance === null) {
+            // TODO: Yep, having a namespace with one singletone instance is not very useful.
+            self::$instance = new self($namespace);
+        }
+
+        return self::$instance;
     }
 
@@ -203,5 +205,5 @@
      * @param  array    $param     Array of parameters (key => val pairs).
      */
-    function setParam($param=null)
+    public function setParam($param=null)
     {
         if (isset($param) && is_array($param)) {
@@ -218,5 +220,5 @@
      * @return  mixed               Parameter value, or null if not existing.
      */
-    function getParam($param=null)
+    public function getParam($param=null)
     {
         if ($param === null) {
@@ -225,5 +227,4 @@
             return $this->_params[$param];
         } else {
-            trigger_error(sprintf('Parameter is not set: %s', $param), E_USER_NOTICE);
             return null;
         }
@@ -237,5 +238,5 @@
      * @since   15 Jul 2005 00:32:21
      */
-    function start()
+    public function start()
     {
         if ($this->running) {
@@ -275,14 +276,14 @@
 
             // DB connection parameters taken from environment variables in the httpd.conf file, readable only by root.
-            if (!empty($_SERVER['DB_SERVER'])) {
+            if (!empty($_SERVER['DB_SERVER']) && !$this->getParam('db_server')) {
                 $this->setParam(array('db_server' => $_SERVER['DB_SERVER']));
             }
-            if (!empty($_SERVER['DB_NAME'])) {
+            if (!empty($_SERVER['DB_NAME']) && !$this->getParam('db_name')) {
                 $this->setParam(array('db_name' => $_SERVER['DB_NAME']));
             }
-            if (!empty($_SERVER['DB_USER'])) {
+            if (!empty($_SERVER['DB_USER']) && !$this->getParam('db_user')) {
                 $this->setParam(array('db_user' => $_SERVER['DB_USER']));
             }
-            if (!empty($_SERVER['DB_PASS'])) {
+            if (!empty($_SERVER['DB_PASS']) && !$this->getParam('db_pass')) {
                 $this->setParam(array('db_pass' => $_SERVER['DB_PASS']));
             }
@@ -394,8 +395,7 @@
      * @since   17 Jul 2005 17:20:18
      */
-    function stop()
+    public function stop()
     {
         session_write_close();
-        restore_include_path();
         $this->running = false;
         $num_queries = 0;
@@ -423,5 +423,5 @@
      * @param string $line    __LINE__.
      */
-    function raiseMsg($message, $type=MSG_NOTICE, $file=null, $line=null)
+    public function raiseMsg($message, $type=MSG_NOTICE, $file=null, $line=null)
     {
         $message = trim($message);
@@ -465,5 +465,5 @@
      * @since   21 Dec 2005 13:09:20
      */
-    function getRaisedMessages()
+    public function getRaisedMessages()
     {
         if (!$this->running) {
@@ -471,5 +471,4 @@
             return false;
         }
-
         return isset($_SESSION['_app'][$this->_ns]['messages']) ? $_SESSION['_app'][$this->_ns]['messages'] : array();
     }
@@ -482,5 +481,5 @@
      * @since   21 Dec 2005 13:21:54
      */
-    function clearRaisedMessages()
+    public function clearRaisedMessages()
     {
         if (!$this->running) {
@@ -503,6 +502,7 @@
      * @since   15 Jul 2005 01:39:14
      */
-    function printRaisedMessages($above='', $below='', $print_gotohash_js=false, $hash='sc-msg')
-    {
+    public function printRaisedMessages($above='', $below='', $print_gotohash_js=false, $hash='sc-msg')
+    {
+
         if (!$this->running) {
             $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
@@ -576,5 +576,5 @@
      * @param string $line      The line of the file where the log event occurs.
      */
-    function logMsg($message, $priority=LOG_INFO, $file=null, $line=null)
+    public function logMsg($message, $priority=LOG_INFO, $file=null, $line=null)
     {
         static $previous_events = array();
@@ -690,5 +690,5 @@
         // SCREEN ACTION
         if (false !== $this->getParam('log_screen_priority') && $priority <= $this->getParam('log_screen_priority')) {
-            echo "[{$event['type']}] [{$event['message']}]\n";
+            file_put_contents('php://stderr', "[{$event['type']}] [{$event['message']}]\n", FILE_APPEND);
         }
 
@@ -706,5 +706,5 @@
      * @return                The string representation of $priority.
      */
-    function logPriorityToString($priority) {
+    public function logPriorityToString($priority) {
         $priorities = array(
             LOG_EMERG   => 'emergency',
@@ -735,5 +735,5 @@
      * @since   13 Oct 2007 11:34:51
      */
-    function setQuery($query_key, $val)
+    public function setQuery($query_key, $val)
     {
         if (!is_array($query_key)) {
@@ -757,5 +757,5 @@
      * @since   14 Nov 2005 19:24:52
      */
-    function carryQuery($query_key, $default=false)
+    public function carryQuery($query_key, $default=false)
     {
         if (!is_array($query_key)) {
@@ -782,5 +782,5 @@
      * @since   18 Jun 2007 20:57:29
      */
-    function dropQuery($query_key, $unset=false)
+    public function dropQuery($query_key, $unset=false)
     {
         if (!is_array($query_key)) {
@@ -818,5 +818,5 @@
      * @return string url with attached queries and, if not using cookies, the session id
      */
-    function url($url, $carry_args=null, $always_include_sid=false)
+    public function url($url, $carry_args=null, $always_include_sid=false)
     {
         if (!$this->running) {
@@ -909,5 +909,5 @@
      * @since   09 Dec 2005 17:58:45
      */
-    function oHREF($url, $carry_args=null, $always_include_sid=false)
+    public function oHREF($url, $carry_args=null, $always_include_sid=false)
     {
         $url = $this->url($url, $carry_args, $always_include_sid);
@@ -929,5 +929,5 @@
      *                                      false  <-- To not carry any queries. If URL already has queries those will be retained.
      */
-    function printHiddenSession($carry_args=null)
+    public function printHiddenSession($carry_args=null)
     {
         if (!$this->running) {
@@ -995,5 +995,5 @@
      * @param   bool    $always_include_sid     Force session id to be added to Location header.
      */
-    function dieURL($url, $carry_args=null, $always_include_sid=false)
+    public function dieURL($url, $carry_args=null, $always_include_sid=false)
     {
         if (!$this->running) {
@@ -1042,5 +1042,5 @@
     * @since    31 Mar 2006 19:17:00
     */
-    function dieBoomerangURL($id=null, $carry_args=null, $default_url=null, $queryless_referrer_comparison=false)
+    public function dieBoomerangURL($id=null, $carry_args=null, $default_url=null, $queryless_referrer_comparison=false)
     {
         if (!$this->running) {
@@ -1085,5 +1085,5 @@
      * FIXME: url garbage collection?
      */
-    function setBoomerangURL($url=null, $id=null)
+    public function setBoomerangURL($url=null, $id=null)
     {
         if (!$this->running) {
@@ -1093,5 +1093,4 @@
         // A redirection will never happen immediately after setting the boomerangURL.
         // Set the time so ensure this doesn't happen. See $app->validBoomerangURL for more.
-        /// FIXME: Why isn't the time set here under setBoomerangURL() and only under dieBoomerangURL()?
 
         if ('' != $url && is_string($url)) {
@@ -1124,5 +1123,5 @@
      * @param string  $id     An identification tag for this url.
      */
-    function getBoomerangURL($id=null)
+    public function getBoomerangURL($id=null)
     {
         if (!$this->running) {
@@ -1149,5 +1148,5 @@
      * @param string  $id     An identification tag for this url.
      */
-    function deleteBoomerangURL($id=null)
+    public function deleteBoomerangURL($id=null)
     {
         if (!$this->running) {
@@ -1171,5 +1170,5 @@
      * @return bool  True if it is set and valid, false otherwise.
      */
-    function validBoomerangURL($id=null, $use_nonspecificboomerang=false)
+    public function validBoomerangURL($id=null, $use_nonspecificboomerang=false)
     {
         if (!$this->running) {
@@ -1221,5 +1220,5 @@
      * the same page but with https.
      */
-    function sslOn()
+    public function sslOn()
     {
         if (function_exists('apache_get_modules')) {
@@ -1242,5 +1241,5 @@
      * a http version of the current url.
      */
-    function sslOff()
+    public function sslOff()
     {
         if ('' != getenv('HTTPS')) {
@@ -1248,7 +1247,3 @@
         }
     }
-
-
 } // End.
-
-?>
